//+------------------------------------------------------------------+
//|                             normalized deviations oscillator.mq4 |
//|                25 August 2011                             mladen |
//|                                                                  |
//| original developed by William Cringan (TASC 2/2003)              |
//+------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_color2     Yellow
#property indicator_width2     2
#property indicator_color3     Red
#property indicator_style3     STYLE_DASH
#property indicator_minimum    -5
#property indicator_maximum    105
#property indicator_level1     10
#property indicator_level2     50
#property indicator_level3     90
#property indicator_levelcolor DarkKhaki

//
//
//
//
//

extern string TimeFrame             = "Current time frame";
extern int    NdoPrice              = PRICE_CLOSE;
extern int    EMAPeriod             = 12;
extern int    AtrPeriod             = 12;
extern int    SigMaPeriod           = 4;
extern int    Ma_Mode               = MODE_LWMA;
extern int    NormPeriod            = 100;
extern int    SmoothLength          = 5;
extern double SmoothPhase           = 0;
extern bool   SmoothDouble          = true;
extern bool   Interpolate           = true;

extern bool   alertsOn              = true;
extern bool   alertsOnCurrent       = false;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = true;
extern bool   alertsEmail           = false; 
extern bool   ShowArrows            = true;
extern string arrowsIdentifier      = "deviationatrcross";
extern color  arrowsUpColor         = White;
extern color  arrowsDnColor         = White;
extern double dnarrowgap            = 5;
extern double uparrowgap            = 5;
extern bool   ShowAtrSlope          = true;
extern string SlopearrowsIdentifier = "atrslope";
extern color  SlopearrowsUpColor    = LimeGreen;
extern color  SlopearrowsDnColor    = Red;
extern double Slopednarrowgap       = 10;
extern double Slopeuparrowgap       = 10;

//
//
//
//
//

double ndo[];
double natr[];
double ndma[];
double dos[];
double atr[];
double temp[];
double trend[];
double slope[];

double point = 0;
double pipMultiplier = 1;

int digit; 

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   for (int i=0; i<indicator_buffers; i++) SetIndexStyle(i,DRAW_LINE);
   
   digit = Digits;
   
   if(digit == 3 || digit == 5)
   { 
      point = Point * 10; 
      pipMultiplier = 10; 
   }
   else
   {
      point = Point;
      pipMultiplier = 1;
   }
   
   IndicatorBuffers(8);
   SetIndexBuffer(0,ndo);
   SetIndexBuffer(1,natr);
   SetIndexBuffer(2,ndma);
   SetIndexBuffer(3,dos);
   SetIndexBuffer(4,atr);
   SetIndexBuffer(5,temp);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,slope);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"   norm deviations + atr  ("+EMAPeriod+","+AtrPeriod+","+SigMaPeriod+")");
 return(0);
}

//
//
//
//
//

int deinit() { if (!calculateValue && ShowArrows) deleteArrows(); if (!calculateValue && ShowAtrSlope) deleteSlopeArrows();  return(0); }

//+-----------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                             |
//+-----------------------------------------------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,s,n,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { ndo[0] = limit+1; return(0); }
    
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for (i=limit; i>=0; i--) temp[i] = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
      for (i=limit; i>=0; i--)
      {
         atr[i] = iMAOnArray(temp,Bars,AtrPeriod,0,Ma_Mode,i);
         dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
         //
         //
         //
         //
         //
         
            double hi     = dos[ArrayMaximum(dos,NormPeriod,i)];
            double lo     = dos[ArrayMinimum(dos,NormPeriod,i)];
            double MaxAtr = atr[ArrayMaximum(atr,NormPeriod,i)];
            double MinAtr = atr[ArrayMinimum(atr,NormPeriod,i)];
         
            if (hi!=lo)
                 ndo[i] = iDSmooth(100*(dos[i]- lo)/(hi - lo),SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
            else ndo[i] = iDSmooth(                         0,SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
            if (MaxAtr!=MinAtr)
                 natr[i] = iDSmooth(100*(atr[i]-MinAtr)/(MaxAtr-MinAtr),SmoothLength,SmoothPhase,SmoothDouble,i,20);
            else natr[i] = iDSmooth(                                  0,SmoothLength,SmoothPhase,SmoothDouble,i,20);
      }
      for (i=limit; i>=0; i--)
      {
         ndma[i]  = iMAOnArray(ndo,Bars,SigMaPeriod,0,Ma_Mode,i);             
         trend[i] = trend[i+1];
         slope[i] = slope[i+1];
                          
           if (ndo[i] > ndma[i] && ndo[i] > natr[i] && ndma[i] > natr[i]) trend[i] =  1;
           if (ndo[i] < ndma[i] && ndo[i] < natr[i] && ndma[i] < natr[i]) trend[i] = -1;
           if (natr[i] > natr[i+1]) slope[i] =  1;
           if (natr[i] < natr[i+1]) slope[i] = -1;
           if (!calculateValue) manageArrow(i);
           if (!calculateValue) manageSlopeArrow(i);
      }
      manageAlerts();
      return (0);
   }
          
   //
   //
   //
   //
   //
    
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
     
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            ndo[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,0,y);
            natr[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,1,y);
            ndma[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,2,y);
            trend[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,6,y);
            slope[i]= iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,7,y);
            
            manageArrow(i);
            manageSlopeArrow(i);
            
            //
            //
            //
            //
            //
            
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(s = 1; s < n; s++)
            {
  	            ndo[i+s]  = ndo[i]  + (ndo[i+n]  - ndo[i])  * s/n;
  	            natr[i+s] = natr[i] + (natr[i+n] - natr[i]) * s/n;
  	            ndma[i+s] = ndma[i] + (ndma[i+n] - ndma[i]) * s/n;
  	  
           }  	            
   }
   
   manageAlerts();
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
   
}

//
//
//
//
//
//+---------------------------------------------------------------------------------------+
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," norm deviation atr trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," norm deviation atr "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,181,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,181,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];  
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,2);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + dnarrowgap * point);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - uparrowgap * point); 
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//
//
//
//
//

void manageSlopeArrow(int i)
{
   if (ShowAtrSlope)
   {
      deleteSlopeArrow(Time[i]);
      if (slope[i]!= slope[i+1])
      {
         if (slope[i] == 1) drawSlopeArrow(i,SlopearrowsUpColor,241,false);
         if (slope[i] ==-1) drawSlopeArrow(i,SlopearrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawSlopeArrow(int i,color theColor,int theCode,bool up)
{
   string slname = SlopearrowsIdentifier+":"+Time[i];  
   
      //
      //
      //
      //
      //
      
      ObjectCreate(slname,OBJ_ARROW,0,Time[i],0);
         ObjectSet(slname,OBJPROP_ARROWCODE,theCode);
         ObjectSet(slname,OBJPROP_COLOR,theColor);
         ObjectSet(slname,OBJPROP_WIDTH,2);
         if (up)
               ObjectSet(slname,OBJPROP_PRICE1,High[i] + Slopednarrowgap * point);
         else  ObjectSet(slname,OBJPROP_PRICE1,Low[i]  - Slopeuparrowgap * point); 
}

//
//
//
//
//

void deleteSlopeArrows()
{
   string lookFor       = SlopearrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteSlopeArrow(datetime time)
{
   string lookFor = SlopearrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//+-----------------------------------------------------------------------------------------
//|                                                                 
//+-----------------------------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}